package org.jbpm.pvm.internal.lob;

import java.sql.SQLException;

import org.hibernate.Hibernate;
import org.jbpm.api.JbpmException;
import org.jbpm.pvm.internal.util.IoUtil;

public class BlobStrategySybase implements BlobStrategy {
  public void set(byte[] bytes, Lob lob) {
    if (bytes!=null) {
      lob.cachedBytes = bytes;
      lob.blob = Hibernate.createBlob(bytes);
    }
  }

  public byte[] get(Lob lob) {
    if (lob.cachedBytes!=null) {
      return lob.cachedBytes;
    }

    java.sql.Blob sqlBlob = lob.blob;
    if (sqlBlob!=null) {
      try {
        return IoUtil.readBytes(sqlBlob.getBinaryStream());
      } catch (SQLException e) {
        throw new JbpmException("couldn't extract bytes out of blob", e);
      }
    }
    return null;
  }
}
